Index: trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Control.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Control.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Control.ab	(revision 698)
@@ -57,4 +57,16 @@
 	End Function
 
+	Function AddRef() As DWord
+		AddRef = comImpl.AddRef()
+	End Function
+
+	Function Release() As DWord
+		Release = comImpl.Release()
+	End Function
+
+	Function QueryInterface(ByRef riid As IID, ByRef pv As Any) As HRESULT
+		QueryInterface = comImpl.QueryInterface(riid, pv)
+	End Function
+
 Private
 	Static Function FromHWndCore(hwnd As HWND) As Control
@@ -70,4 +82,6 @@
 	@date 2008/08/02
 	通常はCreateやCreateFormその他を使ってください。
+	ここで渡された引数は、GetCreateStructへ渡して修正の機会を与えた後に、
+	CreateWindowExへ渡される。
 	*/
 	Sub CreateEx(parent As Control, style As DWord, exStyle As DWord, hmenu As HMENU)
@@ -115,7 +129,13 @@
 
 Protected
+	/*!
+	@brief ウィンドウ作成前の初期設定確認
+	派生クラスでオーバーライドして、csを書き換えてよい。
+	書き換えられたcsを基にCreateWindowExが呼ばれる。
+	*/
 	Virtual Sub GetCreateStruct(ByRef cs As CREATESTRUCT)
 	End Sub
 
+Private
 	Sub createImpl(ByRef cs As CREATESTRUCT, parent As Control)
 		throwIfAlreadyCreated()
@@ -153,4 +173,5 @@
 	End Sub
 */
+
 	Sub BeginSubclass()
 		throwIfNotCreated()
@@ -207,6 +228,5 @@
 Private
 	Static Function makeKeysFormMsg(e As MessageArgs) As Keys
-		Dim t As DWord
-		t = e.WParam And Keys.KeyCode
+		Dim t = (e.WParam As DWord) And Keys.KeyCode
 		t Or= (GetKeyState(VK_SHIFT) As Word And &h8000) << 1
 		t Or= (GetKeyState(VK_CONTROL) As Word And &h8000) << 2
@@ -354,5 +374,14 @@
 
 	Sub OnCreateBase(sender As Object, e As MessageArgs)
-		e.Handled = e.Handled And OnCreate(New CreateArgs(e.LParam As *CREATESTRUCT))
+		Dim c = New CreateArgs(e.LParam As *CREATESTRUCT)
+		If e.LResult = -1 Then
+			c.Cancel = True
+		End If
+		e.Handled = e.Handled And OnCreate(c)
+		If c.Cancel Then
+			e.LResult = -1
+		Else
+			e.LResult = 0
+		End If
 	End Sub
 
@@ -579,5 +608,5 @@
 			.hIcon = 0
 			.hCursor = LoadImage(0, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE Or LR_SHARED) As HCURSOR
-			.hbrBackground = 0
+			.hbrBackground = (COLOR_3DFACE + 1) As HBRUSH
 			.lpszMenuName = 0
 			.lpszClassName = ToTCStr(WindowClassName)
Index: trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/EventArgs.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/EventArgs.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/EventArgs.ab	(revision 698)
@@ -128,5 +128,6 @@
 		This.button = button
 		This.clicks = clicks
-		This.pt = New System.Drawing.Point(x, y)
+		This.pt.X = x
+		This.pt.Y = y
 		This.delta = delta
 	End Sub
@@ -145,5 +146,5 @@
 
 	Const Function Locale() As System.Drawing.Point
-		Locale = New System.Drawing.Point(pt.X, pt.Y)
+		Locale = pt
 	End Function
 
@@ -495,6 +496,15 @@
 		CreateStruct = pcs
 	End Function
+
+	Const Function Cancel() As Boolean
+		Cancel = cancel
+	End Function
+
+	Sub Cancel(c As Boolean)
+		cancel = c
+	End Sub
 Private
 	pcs As *CREATESTRUCT
+	cancel As Boolean
 End Class
 
Index: trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Form.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Form.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/ActiveBasic/Windows/UI/Form.ab	(revision 698)
@@ -19,5 +19,4 @@
 	Sub Form()
 		AddMessageEvent(WM_COMMAND, AddressOf(OnCommand))
-		AddPaintBackground(AddressOf(OnPaintBackground))
 	End Sub
 
@@ -31,9 +30,4 @@
 			.cy = CW_USEDEFAULT
 		End With
-	End Sub
-
-	Sub OnPaintBackground(sender As Object, e As PaintBackgroundArgs)
-		Dim rc = ClientRect
-		FillRect(e.Handle, rc, (COLOR_3DFACE + 1) As HBRUSH)
 	End Sub
 
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/CharacterRange.ab	(revision 698)
@@ -4,52 +4,8 @@
 Namespace Drawing
 
-Class CharacterRange
-Public
-	Sub CharacterRange(f As Long, l As Long)
-		first = f
-		length = l
-	End Sub
-
-	Sub CharacterRange()
-		First = 0
-		Length = 0
-	End Sub
-
-	Function First() As Long
-		Return first
-	End Function
-
-	Sub First(f As Long)
-		first = f
-	End Sub
-
-	Function Length() As Long
-		Return length
-	End Function
-
-	Sub Length(l As Long)
-		length = l
-	End Sub
-
-	Function Operator ==(c As CharacterRange) As Boolean
-		Return Equals(c)
-	End Function
-
-	Function Operator <>(c As CharacterRange) As Boolean
-		Return Not Equals(c)
-	End Function
-
-	Function Equals(c As CharacterRange) As Boolean
-		Return first = c.first And length = c.length
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return first Xor length
-	End Function
-
-Private
-	first As Long
-	length As Long
-End Class
+Type CharacterRange
+	First As Long
+	Length As Long
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Color.ab	(revision 698)
@@ -4,307 +4,5 @@
 Namespace Drawing
 
-Class Color
-Public
-	Sub Color()
-		argb = MakeARGB(255, 0, 0, 0) ' Black
-	End Sub
-
-	Sub Color(ByRef c As Color)
-		argb = c.argb
-	End Sub
-
-	Sub Color(r As Byte, g As Byte, b As Byte)
-		argb = MakeARGB(255, r, g, b)
-	End Sub
-
-	Sub Color(a As Byte, r As Byte, g As Byte, b As Byte)
-		argb = MakeARGB(a, r, g, b)
-	End Sub
-
-	Sub Color(newArgb As System.Drawing.Imaging.ARGB)
-		argb = newArgb
-	End Sub
-
-	Function Operator ==(c As Color) As Boolean
-		Return Equals(c)
-	End Function
-
-	Function Operator <>(c As Color) As Boolean
-		Return Not Equals(c)
-	End Function
-
-	Function A() As Byte
-		A = (argb >> System.Drawing.Imaging.ALPHA_SHIFT) As Byte
-	End Function
-
-	Function R() As Byte
-		R = (argb >> System.Drawing.Imaging.RED_SHIFT) As Byte
-	End Function
-
-	Function G() As Byte
-		G = (argb >> System.Drawing.Imaging.GREEN_SHIFT) As Byte
-	End Function
-
-	Function B() As Byte
-		B = (argb >> System.Drawing.Imaging.BLUE_SHIFT) As Byte
-	End Function
-
-	Function Value() As System.Drawing.Imaging.ARGB
-		Value = argb
-	End Function
-
-	Sub Value(value As System.Drawing.Imaging.ARGB)
-		argb = value
-	End Sub
-
-	Sub SetFromCOLORREF(rgb As COLORREF)
-		If (rgb And &hff000000) = &h01000000 Then
-			Exit Sub ' パレットインデックス指定は無効
-		Else
-			argb = MakeARGB(255, GetRValue(rgb) As Byte, GetGValue(rgb) As Byte, GetBValue(rgb) As Byte)
-		End If
-	End Sub
-
-	Function ToCOLORREF() As COLORREF
-		ToCOLORREF = RGB(R, G, B)
-	End Function
-/*
-	Function ToArgb() As ARGB
-		ToArgb = argb
-	End Function
-*/
-	Static Function FromArgb(argb As System.Drawing.Imaging.ARGB) As Color
-		Return New Color(argb)
-	End Function
-
-	Static Function FromArgb(a As Byte, base As Color) As Color
-		Return New Color(a, base.R, base.G, base.B)
-	End Function
-
-	Static Function FromArgb(r As Byte, g As Byte, b As Byte) As Color
-		Return New Color(r, g, b)
-	End Function
-
-	Static Function FromArgb(a As Byte, r As Byte, g As Byte, b As Byte) As Color
-		Return New Color(a, r, g, b)
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return argb As Long
-	End Function
-
-	Function Equals(c As Color) As Boolean
-		Return argb = c.argb
-	End Function
-
-	' HSBを求める式はhttp://ofo.jp/osakana/cgtips/hsb.phtmlを参考にしました。
-	Function GetHue() As Single
-		Dim max As Long, min As Long, d As Long
-		Dim r = R
-		Dim g = G
-		Dim b = B
-		max = System.Math.Max(System.Math.Max(r, g), b)
-		min = System.Math.Min(System.Math.Min(r, g), b)
-		d = max - min
-		If g = max Then
-			Return ((b - r) As Double / d * 60.0 + 120.0) As Single
-		ElseIf b = max Then
-			Return ((r - g) As Double / d * 60 + 240) As Single
-		ElseIf g < b Then
-			Return ((g - b) As Double / d * 60 + 360) As Single
-		Else
-			Return ((g - b) As Double / d * 60) As Single
-		EndIf
-	End Function
-
-	Function GetSaturation() As Single
-		Dim r = R
-		Dim g = G
-		Dim b = B
-		Dim max = System.Math.Max(System.Math.Max(r, g), b) As Long
-		Dim min = System.Math.Min(System.Math.Min(r, g), b) As Long
-		Return ( (max - min) / max ) As Single
-	End Function
-
-	Function GetBrightness() As Single
-		Dim r = R
-		Dim g = G
-		Dim b = B
-		Dim max = System.Math.Max(System.Math.Max(r, g), b)
-		Return ( max * (1 / 255) ) As Single
-	End Function
-
-/*
-	' Common color constants
-	Const Enum
-		AliceBlue            = &hFFF0F8FF
-		AntiqueWhite         = &hFFFAEBD7
-		Aqua                 = &hFF00FFFF
-		Aquamarine           = &hFF7FFFD4
-		Azure                = &hFFF0FFFF
-		Beige                = &hFFF5F5DC
-		Bisque               = &hFFFFE4C4
-		Black                = &hFF000000
-		BlanchedAlmond       = &hFFFFEBCD
-		Blue                 = &hFF0000FF
-		BlueViolet           = &hFF8A2BE2
-		Brown                = &hFFA52A2A
-		BurlyWood            = &hFFDEB887
-		CadetBlue            = &hFF5F9EA0
-		Chartreuse           = &hFF7FFF00
-		Chocolate            = &hFFD2691E
-		Coral                = &hFFFF7F50
-		CornflowerBlue       = &hFF6495ED
-		Cornsilk             = &hFFFFF8DC
-		Crimson              = &hFFDC143C
-		Cyan                 = &hFF00FFFF
-		DarkBlue             = &hFF00008B
-		DarkCyan             = &hFF008B8B
-		DarkGoldenrod        = &hFFB8860B
-		DarkGray             = &hFFA9A9A9
-		DarkGreen            = &hFF006400
-		DarkKhaki            = &hFFBDB76B
-		DarkMagenta          = &hFF8B008B
-		DarkOliveGreen       = &hFF556B2F
-		DarkOrange           = &hFFFF8C00
-		DarkOrchid           = &hFF9932CC
-		DarkRed              = &hFF8B0000
-		DarkSalmon           = &hFFE9967A
-		DarkSeaGreen         = &hFF8FBC8B
-		DarkSlateBlue        = &hFF483D8B
-		DarkSlateGray        = &hFF2F4F4F
-		DarkTurquoise        = &hFF00CED1
-		DarkViolet           = &hFF9400D3
-		DeepPink             = &hFFFF1493
-		DeepSkyBlue          = &hFF00BFFF
-		DimGray              = &hFF696969
-		DodgerBlue           = &hFF1E90FF
-		Firebrick            = &hFFB22222
-		FloralWhite          = &hFFFFFAF0
-		ForestGreen          = &hFF228B22
-		Fuchsia              = &hFFFF00FF
-		Gainsboro            = &hFFDCDCDC
-		GhostWhite           = &hFFF8F8FF
-		Gold                 = &hFFFFD700
-		Goldenrod            = &hFFDAA520
-		Gray                 = &hFF808080
-		Green                = &hFF008000
-		GreenYellow          = &hFFADFF2F
-		Honeydew             = &hFFF0FFF0
-		HotPink              = &hFFFF69B4
-		IndianRed            = &hFFCD5C5C
-		Indigo               = &hFF4B0082
-		Ivory                = &hFFFFFFF0
-		Khaki                = &hFFF0E68C
-		Lavender             = &hFFE6E6FA
-		LavenderBlush        = &hFFFFF0F5
-		LawnGreen            = &hFF7CFC00
-		LemonChiffon         = &hFFFFFACD
-		LightBlue            = &hFFADD8E6
-		LightCoral           = &hFFF08080
-		LightCyan            = &hFFE0FFFF
-		LightGoldenrodYellow = &hFFFAFAD2
-		LightGray            = &hFFD3D3D3
-		LightGreen           = &hFF90EE90
-		LightPink            = &hFFFFB6C1
-		LightSalmon          = &hFFFFA07A
-		LightSeaGreen        = &hFF20B2AA
-		LightSkyBlue         = &hFF87CEFA
-		LightSlateGray       = &hFF778899
-		LightSteelBlue       = &hFFB0C4DE
-		LightYellow          = &hFFFFFFE0
-		Lime                 = &hFF00FF00
-		LimeGreen            = &hFF32CD32
-		Linen                = &hFFFAF0E6
-		Magenta              = &hFFFF00FF
-		Maroon               = &hFF800000
-		MediumAquamarine     = &hFF66CDAA
-		MediumBlue           = &hFF0000CD
-		MediumOrchid         = &hFFBA55D3
-		MediumPurple         = &hFF9370DB
-		MediumSeaGreen       = &hFF3CB371
-		MediumSlateBlue      = &hFF7B68EE
-		MediumSpringGreen    = &hFF00FA9A
-		MediumTurquoise      = &hFF48D1CC
-		MediumVioletRed      = &hFFC71585
-		MidnightBlue         = &hFF191970
-		MintCream            = &hFFF5FFFA
-		MistyRose            = &hFFFFE4E1
-		Moccasin             = &hFFFFE4B5
-		NavajoWhite          = &hFFFFDEAD
-		Navy                 = &hFF000080
-		OldLace              = &hFFFDF5E6
-		Olive                = &hFF808000
-		OliveDrab            = &hFF6B8E23
-		Orange               = &hFFFFA500
-		OrangeRed            = &hFFFF4500
-		Orchid               = &hFFDA70D6
-		PaleGoldenrod        = &hFFEEE8AA
-		PaleGreen            = &hFF98FB98
-		PaleTurquoise        = &hFFAFEEEE
-		PaleVioletRed        = &hFFDB7093
-		PapayaWhip           = &hFFFFEFD5
-		PeachPuff            = &hFFFFDAB9
-		Peru                 = &hFFCD853F
-		Pink                 = &hFFFFC0CB
-		Plum                 = &hFFDDA0DD
-		PowderBlue           = &hFFB0E0E6
-		Purple               = &hFF800080
-		Red                  = &hFFFF0000
-		RosyBrown            = &hFFBC8F8F
-		RoyalBlue            = &hFF4169E1
-		SaddleBrown          = &hFF8B4513
-		Salmon               = &hFFFA8072
-		SandyBrown           = &hFFF4A460
-		SeaGreen             = &hFF2E8B57
-		SeaShell             = &hFFFFF5EE
-		Sienna               = &hFFA0522D
-		Silver               = &hFFC0C0C0
-		SkyBlue              = &hFF87CEEB
-		SlateBlue            = &hFF6A5ACD
-		SlateGray            = &hFF708090
-		Snow                 = &hFFFFFAFA
-		SpringGreen          = &hFF00FF7F
-		SteelBlue            = &hFF4682B4
-		Tan                  = &hFFD2B48C
-		Teal                 = &hFF008080
-		Thistle              = &hFFD8BFD8
-		Tomato               = &hFFFF6347
-		Transparent          = &h00FFFFFF
-		Turquoise            = &hFF40E0D0
-		Violet               = &hFFEE82EE
-		Wheat                = &hFFF5DEB3
-		White                = &hFFFFFFFF
-		WhiteSmoke           = &hFFF5F5F5
-		Yellow               = &hFFFFFF00
-		YellowGreen          = &hFF9ACD32
-	End Enum
-
-	' Shift count and bit mask for A, R, G, B components
-
-	Const Enum
-		AlphaShift  = 24
-		RedShift    = 16
-		GreenShift  = 8
-		BlueShift   = 0
-	End Enum
-
-	Const Enum
-		AlphaMask   = &hff000000
-		RedMask     = &h00ff0000
-		GreenMask   = &h0000ff00
-		BlueMask    = &h000000ff
-	End Enum
-*/
-	Static Function MakeARGB(a As Byte, r As Byte, g As Byte, b As Byte) As System.Drawing.Imaging.ARGB
-		MakeARGB = (((b As System.Drawing.Imaging.ARGB) <<  System.Drawing.Imaging.BLUE_SHIFT) Or _
-		            ((g As System.Drawing.Imaging.ARGB) << System.Drawing.Imaging.GREEN_SHIFT) Or _
-		            ((r As System.Drawing.Imaging.ARGB) <<   System.Drawing.Imaging.RED_SHIFT) Or _
-		            ((a As System.Drawing.Imaging.ARGB) << System.Drawing.Imaging.ALPHA_SHIFT))
-	End Function
-
-Protected
-	argb As System.Drawing.Imaging.ARGB
-End Class
+TypeDef Color = DWord 'ARGB
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/Matrix.ab	(revision 698)
@@ -5,4 +5,12 @@
 
 Class Matrix
+Public
+	Sub Matrix(native As *GpMatrix)
+		nativeMatrix = native
+	End Sub 
+	Function NativeMatrix() As *GpMatrix
+		NativeMatrix = nativeMatrix
+	End Function
+	nativeMatrix As *GpMatrix
 End Class
 
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Drawing2D/misc.ab	(revision 698)
@@ -3,4 +3,7 @@
 Namespace Drawing
 Namespace Drawing2D
+	
+TypeDef GraphicsContainer = DWord
+TypeDef GraphicsState = DWord
 
 Enum CombineMode
@@ -85,4 +88,54 @@
 End Enum
 
+Enum DashStyle
+	Solid           ' 0
+	Dash            ' 1
+	Dot             ' 2
+	DashDot         ' 3
+	DashDotDot      ' 4
+	Custom          ' 5
+End Enum
+
+Enum DashCap
+	Flat             = 0
+	Round            = 2
+	Triangle         = 3
+End Enum
+
+Enum LineCap
+	Flat             = 0
+	Square           = 1
+	Round            = 2
+	Triangle         = 3
+	NoAnchor         = &h10
+	SquareAnchor     = &h11
+	RoundAnchor      = &h12
+	DiamondAnchor    = &h13
+	ArrowAnchor      = &h14
+	Custom           = &hff
+	AnchorMask       = &hf0
+End Enum
+
+Enum LineJoin
+	Miter = 0
+	Bevel = 1
+	Round = 2
+	Clipped = 3
+End Enum
+
+Enum PenAlignment
+	Center       = 0
+	Inset        = 1
+End Enum
+
+Enum PenType
+	SolidColor       = 0 'BrushTypeSolidColor
+	HatchFill        = 1 'BrushTypeHatchFill
+	TextureFill      = 2 'BrushTypeTextureFill
+	PathGradient     = 3 'BrushTypePathGradient
+	LinearGradient   = 4 'BrushTypeLinearGradient
+	Unknown          = -1
+End Enum
+
 End Namespace
 End Namespace
